package credit_balance

import (
	"context"

	"wechat-api/internal/svc"
	"wechat-api/internal/types"
	"wechat-api/internal/utils/dberrorhandler"

    "github.com/suyuan32/simple-admin-common/msg/errormsg"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateCreditBalanceLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewCreateCreditBalanceLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateCreditBalanceLogic {
	return &CreateCreditBalanceLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *CreateCreditBalanceLogic) CreateCreditBalance(req *types.CreditBalanceInfo) (*types.BaseMsgResp, error) {
    _, err := l.svcCtx.DB.CreditBalance.Create().
			SetNotNilUserID(req.UserId).
			SetNotNilBalance(req.Balance).
			SetNotNilStatus(req.Status).
			SetNotNilOrganizationID(req.OrganizationId).
			Save(l.ctx)

    if err != nil {
		return nil, dberrorhandler.DefaultEntError(l.Logger, err, req)
	}

    return &types.BaseMsgResp{Msg: errormsg.CreateSuccess}, nil
}
